import os
import sys
import time


sys.path.append(os.getcwd())

from spider.crawler_offline import *
from spider.crawler_offline.shipinshuashua_id import SPSSIdRecommend
from spider.crawler_offline.xiaoniangao_zhanghao import XiaoNianGaoZH

class SpiderHome(object):
    @classmethod
    def run_xng_plus(cls):
        rule_dict1 = {
            "period": {"min": 365, "max": 365},
            "duration": {"min": 30, "max": 1800},
            "favorite_cnt": {"min": 0, "max": 0},
            "videos_cnt": {"min": 5000, "max": 0},
            "share_cnt": {"min": 0, "max": 0},
        }
        while True:
            XiaoNianGaoPlusRecommend(
                "recommend",
                "xiaoniangaoplus",
                "prod",
                rule_dict1,
                [64120158, 64120157, 63676778],
            )
            time.sleep(600)

    @classmethod
    def run_spss(cls):
        rule_dict = {
            "videos_cnt": {"min": 600, "max": 600},
            "play_cnt": {"min": 5000, "max": 5000}
        }
        SPSSRecommend(
            log_type="recommend",
            crawler="shipinshuashua",
            env="prod",
            rule_dict=rule_dict,
            our_uid=[66433018, 66433020, 66433022, 66433023, 66433024]
        )

    @classmethod
    def run_zfhybf(cls):
        # rule_dict = {
        #     "videos_cnt": {"min": 600, "max": 600},
        #     "play_cnt": {"min": 5000, "max": 5000}
        # }
        ZFHYBFRecommend(
            log_type="recommend",
            crawler="zhufuhaoyunbaofu",
            env="prod",
            rule_dict={},
            our_uid=[68560236, 68560235, 68560234, 68560233, 68560232, 68560231]
        )

    @classmethod
    def run_spss_id(cls):
        SPSSIdRecommend(
            env="prod"
        )

    @classmethod
    def run_xng_id(cls):
        XiaoNianGaoZH()
