"""
爬虫的配置map， 一个大字典；
key是spider的platform
sub_key是recommend，author, value；
value是爬虫封装好的类
"""
from spider.crawler_online import *
from spider.crawler_online.benshanzhufu import BSZHRecommend
from spider.crawler_online.dakaiyinghaoyun import DKYHYRecommend
from spider.crawler_online.fuqihaoyundao import FQHYDRecommend
from spider.crawler_online.haoyoushipin import HYSPRecommend
from spider.crawler_online.haoyunzhufuduo import HYZFDfRecommend
from spider.crawler_online.jierizhufuhuakaifugui import JRZFHKFGRecommend
from spider.crawler_online.jierizhufuxingfujixiang import JRZFXFJXRecommend
from spider.crawler_online.laonianquan import LNQRecommend
from spider.crawler_online.laonianshenghuokuaile import LNSHKLRecommend
from spider.crawler_online.lepaoledong import LPLDRecommend
from spider.crawler_online.lepaoledongdijie import LPLDDJRecommend
from spider.crawler_online.linglingkuailezhufu import LlklzfRecommend
from spider.crawler_online.piaoquangushi import PQGSRecommend
from spider.crawler_online.quzhuan import QZRecommend
from spider.crawler_online.weiquanshipin import WQSPRecommend
from spider.crawler_online.xiaoniangaotuijianliu import XNGTJLRecommend
from spider.crawler_online.xinshiquan import XSQRecommend
from spider.crawler_online.yuannifuqimanman import YNFQMMRecommend
from spider.crawler_online.zhufudewenhou import ZFDWHRecommend
from spider.crawler_online.zhufukuaizhuan import ZFKZRecommend
from spider.crawler_online.zhufuniannianshunxinjixiang import ZFNNSXJXRecommend
from spider.crawler_online.zhufuquanzituijianliu import ZFQZTJLRecommend
from spider.crawler_online.chaojipiaoquan import CJPQRecommend
from spider.crawler_online.xuanlanzhufu import XLZFRecommend
from spider.crawler_online.zhaozhaohuanxizhufuyu import ZZHXZFYRecommend
from spider.crawler_online.zhongqingkandian import ZhongQingKanDianRecommend
from spider.crawler_online.zhongqingkandian_related_recommend import ZhongQingKanDianRelatedRecommend
from spider.crawler_author.zhongqingkandian_author import ZhongQingKanDianAuthor
spider_map = {
    # 祝万物复苏
    "zhuwanwufusunew": {
        "recommend": ZhuWanWuFuSuRecommend
    },
    # 祝好事多磨
    "zhuhaoshiduomo": {
        "recommend": ZhuHaoShiDuoMoRecommend
    },
    # 福小顺
    "fuxiaoshun": {
        "recommend": FuXiaoShunRecommend
    },
    # 祝尽善尽美
    "zhujinshanjinmeinew": {
        "recommend": ZhuJinShanJinMeiRecommend
    },
    # 欢欢喜喜祝福到
    "huanhuanxixizhufudaonew": {
        "recommend": HHXXZFDRecommend
    },
    # 博清科技-祝福咱们中老年之视频
    "boqingzhufu": {
        "recommend": BoQingZhuFu
    },
    # 鲸鱼祝福
    "sharkzhufu": {
        "recommend": SharkZhuFuRecommend
    },
    # 佳节祝福喜事多多
    "xishiduoduo": {
        "recommend": XiShiDuoDuoRecommend
    },
    # 吉祥幸福
    "jixiangxingfu": {
        "recommend": JXXFRecommend
    },
    # 小年糕-话题
    "xiaoniangaohuati": {
        "recommend": XNGHTecommend
    },
    # 福气旺系列, 愿你福气常在
    "yuannifuqichangzai": {
        "recommend": YuanNiFuQiChangZai
    },
    # 福气旺系列， 最好的送你
    "zuihaodesongni": {
        "recommend": ZuiHaoDeSongNi
    },
    # 节日祝福类
    "jierizhufu": {
        "recommend": JieRiZhuFu
    },
    # 打开迎好运
    "dakaiyinghaoyun": {
        "recommend": DKYHYRecommend
    },
    # 福气矩阵-天天聚福气
    "tiantianjufuqi": {
        "recommend": TTJFFQRecommend
    },
    # 小年糕推荐流
    "xiaoniangaotuijianliu": {
        "recommend": XNGTJLRecommend
    },
    # 本山祝福
    "benshanzhufu": {
        "recommend": BSZHRecommend
    },
    # 祝福圈子推荐流
    "zhufuquanzituijianliu": {
        "recommend": ZFQZTJLRecommend
    },
    # 乐跑乐动
    "lepaoledong": {
        "recommend": LPLDRecommend
    },
    # 篻圈故事
    "piaoquangushi": {
        "recommend": PQGSRecommend
    },
    # 微圈视频
    "weiquanshipin": {
        "recommend": WQSPRecommend
    },
    # 祝福快转
    "zhufukuaizhuan": {
        "recommend": ZFKZRecommend
    },
    # 玲玲快乐祝福
    "linglingkuailezhufu": {
        "recommend": LlklzfRecommend
    },
    # 节日祝福花开富贵
    "jierizhufuhuakaifugui": {
        "recommend": JRZFHKFGRecommend
    },
    # 愿你福气满满
    "yuannifuqimanman": {
        "recommend": YNFQMMRecommend
    },
    # 好运祝福多
    "haoyunzhufuduo": {
        "recommend": HYZFDfRecommend
    },
    # 乐跑乐动迪捷
    "lepaoledongdijie": {
        "recommend": LPLDDJRecommend
    },
    # 祝福年年顺心吉祥
    "zhufuniannianshunxinjixiang": {
        "recommend": ZFNNSXJXRecommend
    },
    # 节日祝福幸福吉祥
    "jierizhufuxingfujixiang": {
        "recommend": JRZFXFJXRecommend
    },
    # 好友视频
    "haoyoushipin": {
        "recommend": HYSPRecommend
    },
    # 趣转
    "quzhuan": {
        "recommend": QZRecommend
    },
    # 祝福的问候
    "zhufudewenhou": {
        "recommend": ZFDWHRecommend
    },
    # 老年圈
    "laonianquan": {
        "recommend": LNQRecommend
    },
    # 老年生活快乐
    "laonianshenghuokuaile": {
        "recommend": LNSHKLRecommend
    },
    # 新视圈
    "xinshiquan": {
        "recommend": XSQRecommend
    },
    # 福气好运到
    "fuqihaoyundao": {
        "recommend": FQHYDRecommend
    },
    # 超级票圈
    "chaojipiaoquan": {
        "recommend": CJPQRecommend
    },
    # 绚烂祝福
    "xuanlanzhufu": {
        "recommend": XLZFRecommend
    },
    # 朝朝欢喜祝福语
    "zhaozhaohuanxizhufuyu": {
        "recommend": ZZHXZFYRecommend
    },
    # 中青看点推荐
    "zhongqingkandian": {
        "recommend": ZhongQingKanDianRecommend
    },
    # 中青看点相关推荐
    "zhongqingkandianrelated":{
        "related": ZhongQingKanDianRelatedRecommend
    },
    # 中青看点用户
    "zhongqingkandianauthor":{
        "author": ZhongQingKanDianAuthor
    }
}
